//! Unit tests
use super::*;

/// Testing iteration
mod iteration {
    use super::*;
    #[test]
    fn single_threaded_trivial()
    {
	let pop = Populator::new(10);

	for r in pop.iter()
	{
	    r.insert(1usize);
	}

	assert_eq!(10usize, pop.complete().into_iter().sum::<usize>(), "Did not set all elements to 1");
    }
    #[test]
    fn single_threaded_nontrivial()
    {
	let pop = Populator::new(10);

	for r in pop.iter()
	{
	    r.insert(String::from("1"));
	}

	assert_eq!(10usize, pop.complete().into_iter()
		   .map(|x| x.parse::<usize>().unwrap())
		   .sum::<usize>(), "Did not set all elements to 1");
    }
}
